import { VersionedTextDocumentIdentifier, Range, CodeLens } from 'vscode-languageclient';
import * as VSCode from 'vscode';
export declare function toVSRange(rng: Range): VSCode.Range;
export interface HighlightParams {
    doc: VersionedTextDocumentIdentifier;
    codeLenses: CodeLens[];
}
export declare class HighlightService {
    DECORATION: VSCode.TextEditorDecorationType;
    highlights: Map<String, HighlightParams>;
    dispose(): void;
    constructor();
    handle(params: HighlightParams): void;
    refresh(docId: VersionedTextDocumentIdentifier): void;
    private updateHighlightsForEditor;
}
